# Scalajs-react independent demo

This is a demo of an independent scalajs sbt project consisting of only the frontend, that communicates with the backend from the [play-slick-demo project](https://git.arcusiridis.com/nova/Scala-Play-Slick-Demo) -
This is useful because configuring play to serve frontend files is a hassle, libray bundling mode refused to work for me in the integrated project whereas here it's trivial. Library bundling mode makes incremental compilation really fast( ~2 seconds ). This also speeds up incremental compilation of the backend project.

I have ported over all the code from my previous scalajs-react project, and this is the one I will be using primarily from now.

Other features are -

1. HOCON configuration to make backend url conifgurable
2. Scalajs-react with routing for SPA
3. Effect wrappers (cats IO/monix Task) (TODO)

## Usage

Steps -

1. Clone this project
2. Clone [backend project](https://git.arcusiridis.com/nova/Scala-Play-Slick-Demo)
3. Run the [backend project](https://git.arcusiridis.com/nova/Scala-Play-Slick-Demo)
4. Configure the url for the backend project in this project 's application.conf file
5. Run this project with -
   ```
    sbt "fastOptJS::startWebpackDevServer; ~fastOptJS" shell
   ```
   This starts the webpack dev server, the scalajs-bundler to bundle js dependencies, and js file continuous compilation
6. Open `http://localhost:8080` to see it in action
