package com.example.playscalajsreact.route

sealed trait Page
object Page {
  case object Home extends Page
  case object Hello extends Page
  case class Person(user: String, age: Int) extends Page
  case class ID(id: Int) extends Page

  case class Menu(name: String, route: Page)
  case class Product(category: Int, item: Int) extends Page
  case class Item(category: String, itemId: java.util.UUID) extends Page
  case object Editor extends Page
  case object Test extends Page
}
